/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is WebMail Notifier.
 *
 * The Initial Developer of the Original Code is
 * Byung-Wook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var mailName=["Daum","Naver","Empas","Nate","Gmail"];

function wmn_ui() {
  this.mailCount=[];
  this.mailTab=[];
  for(var i=0;i<Components.interfaces.nsIWebMailNotifier.NUM_OF_MAILS;i++)this.mailCount[i]=0;
}

function openTab(url,name) {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);
  var enum = wm.getEnumerator("navigator:browser");
  while(enum.hasMoreElements()){
    var browser = enum.getNext().getBrowser();
    for (var i = 0;i< browser.mTabContainer.childNodes.length;i++){
      var tab = browser.mTabContainer.childNodes[i];
      if (tab.hasAttribute("tabname")&&tab.getAttribute("tabname")==name) {
        browser.getBrowserForTab(tab).loadURIWithFlags(url);
        //browser.selectedTab = tab;
        browser.contentWindow.focus();
        return;
      }
    }
  }
  //not found
  var tab = getBrowser().selectedTab;
  if(getBrowser().getBrowserForTab(tab).currentURI.spec=="about:blank"
    &&!tab.hasAttribute("tabname")){
    getBrowser().getBrowserForTab(tab).loadURIWithFlags(url);
  }else{
    tab=getBrowser().addTab(url)
  }
  tab.setAttribute("tabname",name);
}
function openWindow(url,name) {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);
  var enum = wm.getEnumerator("navigator:browser");
  while(enum.hasMoreElements()){
    var browser=enum.getNext().getBrowser();
    var win = browser.contentWindow;
    if(win.name==name){
      browser.loadURIWithFlags(url);
      win.focus();
      return;
    }
  }
  //not found
  window.open(url,name);
}
wmn_ui.prototype.onClick = function(aEvent) {
  // on windows, right click calls this method
  if (aEvent && (aEvent.button == 2))
    return;

  var openInTab=checkOpenType();

  for(var i=0;i<this.mailCount.length;i++){
    if(this.mailCount[i]>0){
      _openMail(i,openInTab);
    }
  }
}
function checkOpenType(){
  var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
  var branch = prefService.getBranch("wm-notifier.");
  branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
  return branch.getBoolPref("openInTab");
}
function _openMail(id,openInTab){
  if(openInTab){
    openTab(gWMN_UI.nsIWebMailNotifier.getMailURL(id),"webmail"+id);
  }else openWindow(gWMN_UI.nsIWebMailNotifier.getMailURL(id),"webmail"+id);
}
wmn_ui.prototype.openMail = function(id) {
  _openMail(id,checkOpenType());
}
wmn_ui.prototype.checkNow = function() {
  gWMN_UI.nsIWebMailNotifier.checkMails();
}
wmn_ui.prototype.preferences = function() {
  window.openDialog("chrome://wm-notifier/content/wmn-pref.xul", "wmn-pref", "chrome,titlebar,toolbar,centerscreen,modal")
}
/***********************************************************
WebMailListener implementation
***********************************************************/
wmn_ui.prototype.onStateChange = function(aID,aCount){
  this.mailCount[aID]=aCount;
  if(!document||!document.getElementById("wm-notifier-statusbar"))return;
  //clear tooltip message
  var msgbox=document.getElementById("tooltip-text");
  while(msgbox.firstChild != null){
     msgbox.removeChild(msgbox.firstChild);
  }

  var total=0;
  for(var i=0;i<this.mailCount.length;i++){
    if(this.mailCount[i]>0){
      total+=this.mailCount[i];

      var desc = document.createElement("description");
      desc.setAttribute("value",mailName[i]+" : "+this.mailCount[i]);
      desc.setAttribute("style","color: green;");
      msgbox.appendChild(desc);
    }
  }
  if(total==0){
      var desc = document.createElement("description");
      desc.setAttribute("value","No new mail.");
      desc.setAttribute("style","color: grey;");
      msgbox.appendChild(desc);
  }
  for(var i=0;i<this.mailCount.length;i++){
    if(this.mailCount[i]<0){
      var desc = document.createElement("description");
      desc.setAttribute("value",mailName[i]+" : not checked.");
      desc.setAttribute("style","color: red;");
      msgbox.appendChild(desc);
    }
  }
  document.getElementById("wm-notifier-statusbar").setAttribute("newMail", total>0);
  document.getElementById("wm-notifier-statusbar").setAttribute("label",total>0?total:"");
}
/**********************************************************/

wmn_ui.prototype.onload = function() {
  // this is false if we are in ff's customize window
  if (document.getElementById("wm-notifier-statusbar")) {
    try {
      gWMN_UI.nsIWebMailNotifier = Components.classes["@mozilla.org/WebMailNotifier;1"]
                                                  .getService(Components.interfaces.nsIWebMailNotifier);
      gWMN_UI.nsIWebMailNotifier.addListener(gWMN_UI);
    } catch (e) {
    }
    window.removeEventListener("load", gWMN_UI.onload, false);
  }
}

// shutdown
wmn_ui.prototype.onunload = function() {
  if (document.getElementById("wm-notifier-statusbar")) {
    // remove the listener
    if (gWMN_UI.nsIWebMailNotifier)
      gWMN_UI.nsIWebMailNotifier.removeListener(gWMN_UI);
  }
  gWMN_UI = null;
}

var gWMN_UI = new wmn_ui();

window.addEventListener("load", gWMN_UI.onload, false);
window.addEventListener("unload", gWMN_UI.onunload, false);
